<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>MFA Enroll</title>
    <!-- CSS -->
    <link rel="stylesheet" th:href="@{../assets/css/intl-tel-input.css}">
    <link rel="stylesheet" th:href="@{../assets/css/main.css}">

    <!-- Favicon and touch icons -->
    <link rel="shortcut icon" th:href="${theme.faviconUrl} ?: @{../assets/ico/favicon.ico}">

    <!-- Custom CSS -->
    <style th:if="${theme.css}" th:text="${theme.css}"></style>
    <style th:if="${theme.customCss}" th:text="${theme.customCss}"></style>
</head>
<body>
<div class="container">
    <div class="header">
        <img class="logo" th:src="${theme.logoUrl} ?: @{../assets/images/gravitee-logo.svg}">
        <div class="title">
            <span id="enrollment-title" th:text="#{mfa_enroll.title}"/>
        </div>
        <div class="header-description">
            <span id="enrollment-description" th:text="#{mfa_enroll.description}"/>
        </div>
    </div>

    <div class="section">
        <form role="form" th:action="${action}" method="post" class="form">
            <!-- STEP 1 -->
            <div id="mfa-enroll-step1" class="section card-section">
                <div th:each="factor,factIter : ${factors}">
                    <div th:if="${factor.factorType == 'TOTP'}" class="radio-card">
                        <div class="card-content">
                            <span class="radio">
                                <input type="radio" th:name="factorId" th:value="${factor.id}">
                            </span>
                            <span class="radio-detail">
                                <span class="enroll-name" th:text="#{mfa.otp}"/>
                                <span class="enroll-description" th:text="#{mfa_enroll.otp.description}"/>
                            </span>
                        </div>
                    </div>

                    <div th:if="${factor.factorType == 'SMS' || factor.factorType == 'CALL'}" class="radio-card">
                        <div class="card-content">
                            <span class="radio">
                                <input type="radio" th:name="factorId" th:value="${factor.id}">
                            </span>
                            <span class="radio-detail">
                                <span class="enroll-name" th:text="#{mfa.sms}"/>
                                <span class="enroll-description" th:text="#{mfa_enroll.sms.description}"/>
                            </span>
                        </div>
                    </div>

                    <div th:if="${factor.factorType == 'EMAIL'}" class="radio-card">
                        <div class="card-content">
                            <span class="radio">
                                <input type="radio" th:name="factorId" th:value="${factor.id}">
                            </span>
                            <span class="radio-detail">
                                <span class="enroll-name" th:text="#{mfa.email}"/>
                                <span class="enroll-description" th:text="#{mfa_enroll.email.description}"/>
                            </span>
                        </div>
                    </div>

                    <div th:if="${factor.factorType == 'HTTP'}" class="radio-card">
                        <div class="card-content">
                            <span class="radio">
                                <input type="radio" th:name="factorId" th:value="${factor.id}">
                            </span>
                            <span class="radio-detail">
                                <span class="enroll-name" th:text="#{mfa.http}"/>
                                <span class="enroll-description" th:text="#{mfa_enroll.http.description}"/>
                            </span>
                        </div>
                    </div>

                    <div th:if="${factor.factorType == 'FIDO2'}" class="radio-card">
                        <div class="card-content">
                            <span class="radio">
                                <input type="radio" th:name="factorId" th:value="${factor.id}">
                            </span>
                            <span class="radio-detail">
                                <span class="enroll-name" th:text="#{mfa.fido}"></span>
                                <span class="enroll-description" th:text="#{mfa_enroll.fido.description}"></span>
                            </span>
                        </div>
                    </div>
                </div>
                <button id="next" type="button" class="button primary" th:text="#{mfa_enroll.button.submit}"></button>
            </div>
            <!-- END OF STEP 1 -->

            <!-- STEP 2 -->
            <div id="mfa-enroll-step2" class="section card-section hide">
                <!-- TOTP FACTOR -->
                <div id="otp-factor" class="section enrollment-item hide">
                    <span class="enrollment-card-label" th:text="#{mfa.otp}"/>
                    <span class="enrollment-card-description otp-card-description" th:text="#{mfa_enroll.otp}"/>
                    <div class="otp-container">
                        <img id="qrCode"/>
                    </div>
                </div>
                <!-- SMS|CALL FACTOR -->
                <div id="sms-factor" class="section enrollment-item hide">
                    <span class="enrollment-card-label" th:text="#{mfa.sms}"/>
                    <span class="enrollment-card-description" th:text="#{mfa_enroll.sms}"/>
                    <input class="input-field" placeholder="Phone number" type="tel" id="phone" name="phone">
                    <div id="invalidPhoneNumber" class="item error-text hide">
                        <span>
                            <small th:text="#{mfa_enroll.call}"></small>
                         </span>
                    </div>
                </div>
                <!-- EMAIL FACTOR -->
                <div id="email-factor" class="section enrollment-item hide">
                    <span class="enrollment-card-label" th:text="#{mfa.email}"/>
                    <span class="enrollment-card-description" th:text="#{mfa_enroll.email}"/>
                    <input class="input-field" placeholder="Email" type="email" id="email" name="email">
                </div>
                <!-- HTTP FACTOR -->
                <div id="http-factor" class="section enrollment-item hide">
                    <span class="enrollment-card-label" th:text="#{mfa.http}"/>
                    <span class="enrollment-card-description" th:text="#{mfa_enroll.http}"></span>
                </div>
                <!-- FIDO2 FACTOR -->
                <div id="fido2-factor" class="section enrollment-item hide">
                    <span class="enrollment-card-label" th:text="#{mfa.fido}"/>
                    <span class="enrollment-card-description" th:text="#{mfa_enroll.fido}"/>
                </div>
                <input type="hidden" id="sharedSecret" name="sharedSecret" value=""/>
                <div>
                    <button id="submit" type="submit" name="user_mfa_enrollment" value="true" class="button primary" th:text="#{mfa_enroll.button.submit}"></button>
                </div>
            </div>
            <!-- END OF STEP 2 -->
            <input type="hidden" th:name="${_csrf.parameterName}" th:value="${_csrf.token}"/>
            <div class="section">
                <button th:if="${mfa_force_enrollment == false}" type="submit" name="user_mfa_enrollment" value="false" class="button secondary" th:text="#{mfa_enroll.button.skip}"></button>
                <a id="previous" class="hide" href="#"><span class="icons">arrow_back</span><span th:text="#{mfa_enroll.button.back}"/></a>
            </div>
        </form>
    </div>
</div>

<script th:src="@{../assets/js/jquery-3.5.1.min.js}"></script>
<script th:src="@{../assets/js/intl-tel-input-17.0.8.min.js}"></script>
<script th:inline="javascript" th:attr="nonce=${script_inline_nonce}">
    /*<![CDATA[*/
    let intlTelInput = {};
    function initializeIntlTelInput(phoneInputField, countries) {
        // Handle international prefixes, format phone input field
        // Uses intl-tel-input plugin
        intlTelInput = window.intlTelInput(phoneInputField, {
            autoPlaceholder: "off",
            dropdownContainer: document.body,
            onlyCountries: countries,
            utilsScript: "../assets/js/intl-tel-input-17.0.8-utils.js",
        });
    }

(function() {

    // next button function
    const nextBtnHandler = function () {
        const title=/*[[#{mfa_enroll.on.select.title}]]*/ '';
        const description=/*[[#{mfa_enroll.on.select.description}]]*/ '';
        const factors = /*[[${factors}]]*/ [];
        const phoneNumber = /*[[${phoneNumber}]]*/ '';
        const emailAddress = /*[[${emailAddress}]]*/ '';
        const factorId = document.querySelector('input[name="factorId"]:checked').value;
        const selectedFactor = factors.find(factor => factor.id === factorId);
        let inputElement;

        if (selectedFactor.factorType === 'TOTP') {
            document.getElementById('sharedSecret').value = selectedFactor.enrollment.key;
            document.getElementById('qrCode').src = selectedFactor.enrollment.barCode;
            document.getElementById('otp-factor').classList.remove('hide');
        }

        if (selectedFactor.factorType === 'SMS' || selectedFactor.factorType === 'CALL') {
            document.getElementById('phone').value = phoneNumber;
            initializeIntlTelInput(document.getElementById('phone'), selectedFactor.enrollment.countries);
            const smsFactorDiv = document.getElementById('sms-factor');
            smsFactorDiv.classList.remove('hide');
            inputElement = smsFactorDiv.getElementsByTagName('INPUT')[0];
            // Hide the phoneNumber validation error just after the click on next button
            // to avoid a remaining error if the user go a first time on SMS factor
            document.getElementById('invalidPhoneNumber').classList.add('hide');
        }

        if (selectedFactor.factorType === 'EMAIL') {
            document.getElementById('sharedSecret').value = selectedFactor.enrollment.key;
            document.getElementById('email').value = emailAddress;
            document.getElementById('email').setAttribute('required', '');
            const emailFactorDiv = document.getElementById('email-factor');
            emailFactorDiv.classList.remove('hide');
            inputElement = emailFactorDiv.getElementsByTagName('INPUT')[0];
        }

        if (selectedFactor.factorType === 'HTTP') {
            document.getElementById('http-factor').classList.remove('hide');
        }

        if (selectedFactor.factorType === 'FIDO2') {
            document.getElementById('fido2-factor').classList.remove('hide');
        }

        document.getElementById('enrollment-title').innerHTML = title;
        document.getElementById('enrollment-description').innerHTML = description;
        document.getElementById('mfa-enroll-step1').classList.add('hide');
        document.getElementById('mfa-enroll-step2').classList.remove('hide');
        document.getElementById('previous').classList.remove('hide');
        if(inputElement){
            inputElement.focus();
        }
    }

    const nextBtn = document.getElementById('next');
    nextBtn.disabled = true;
    nextBtn.classList.add('button-disabled');
    nextBtn.addEventListener('click', nextBtnHandler);

    // previous button function
    const previousBtn = document.getElementById('previous');
    previousBtn.addEventListener('click', function () {
        const title=/*[[#{mfa_enroll.title}]]*/ '';
        const description=/*[[#{mfa_enroll.description}]]*/ '';
        document.getElementById('enrollment-title').innerHTML = title;
        document.getElementById('enrollment-description').innerHTML = description;
        [...document.querySelectorAll('.enrollment-item')].forEach(el => el.classList.add('hide'));
        document.getElementById('mfa-enroll-step1').classList.remove('hide');
        document.getElementById('mfa-enroll-step2').classList.add('hide');
        document.getElementById('previous').classList.add('hide');
        document.getElementById('email').removeAttribute('required');
    });

    // radio buttons function
    const inputRadios = document.querySelectorAll('input[type="radio"]');
    inputRadios.forEach(el => el.addEventListener('click', function () {
        // remove active class for every radio cards
        [...document.querySelectorAll('.radio-card')].forEach(el1 => el1.classList.remove('active'));
        // add active class for the selected radio card
        el.closest('.radio-card').classList.add('active');
        // enable next button if at least one factor option is enabled
        nextBtn.disabled = false;
        nextBtn.classList.remove('button-disabled');
    }));

    // submit form function
    const submitBtn = document.getElementById('submit');
    submitBtn.addEventListener('click', function($event) {
        //do not submit the form on 'enter' key press if the following condition satisfied
        //rather call the next button handler functionality
        if(document.getElementById('mfa-enroll-step2').classList.contains("hide")){
            $event.preventDefault();
            nextBtnHandler();
            return;
        }

        // check phone number value if any
        const factors = /*[[${factors}]]*/ [];
        const factorId = document.querySelector('input[name="factorId"]:checked').value;
        const selectedFactor = factors.find(factor => factor.id === factorId);
        if (selectedFactor.factorType === 'SMS' || selectedFactor.factorType === 'CALL') {
            const phoneInput = intlTelInput;
            const phoneNumber = phoneInput.getNumber();
            if (phoneInput.isValidNumber()) {
                document.getElementById('invalidPhoneNumber').classList.add('hide');
                document.getElementById('phone').value = phoneNumber;
            } else {
                // do not submit form in case of wrong number
                document.getElementById('invalidPhoneNumber').classList.remove('hide');
                $event.preventDefault();
            }
        }
    });

    // phone input function
    const phoneInput = document.getElementById('phone');
    phoneInput.addEventListener('keydown', function() {
        document.getElementById('invalidPhoneNumber').classList.add('hide');
    });
})();
    /*]]>*/
</script>
</body>
</html>
